/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : AirInitializer.h                                         */
/*                                                                       */
/*       Date : May, 1997                                                */
/* Updated at : December 6, 1997                                         */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*
    Initialize the first population randomly.
*/
/*************************************************************************/

#include "AirInitializer.h"
#include "AirChromosomes.h"
#include "AirScheduleSolu2.h"
#include <Initializer.h>
#include <Population.h>
#include <Chromosomes.h>
#include <stdio.h>
#include <iostream.h>
#include <iomanip.h>

/*************************************************************************/
/** This object creates the first population.                            */
/*************************************************************************/

AirInitializer::AirInitializer(AirScheduleProblem *Pr)
{  AirChromosomes k;
   cout << " AirChromosomes is defined " << endl;
   k.setProblem(Pr);
   a = (Chromosomes *) (&k);
   cout << *((AirScheduleSolu2*)(&k)); 
   myProblem = Pr;
}// end of constructor

/*************************************************************************/
/** Adds the given list of chromosomes to the Population                 */
/*************************************************************************/

void AirInitializer::updateFromPopulation(Population& Pop, 
			Chromosomes *ChroList[], int Size)
{
   int i;
   for(i=0;i<Size;i++) Pop.addChromosomes(ChroList[i]);

}// end of updateFromPopulation()

/*************************************************************************/
/** This object produces the first population with randomly .            */
/*************************************************************************/

void AirInitializer::apply(Population & Pop)
{  int i, limit = Pop.getSize();

   cout << " in AirInitializer::apply() " << endl;

   AirChromosomes *k;

   for(i=0;i<limit;i++)
   {  k = new AirChromosomes(myProblem); 
      cout << " in AirInitializer::apply() created the object " << endl;
      (*k).randomInitialize();
      cout << "  (*k).randomInitialize() is safe " << endl;
      Pop.addChromosomes(k);
      cout << i << "th chromosome is added " << endl;
   }// end of for

   cout << Pop;

   cout << "Before the  Pop.printFitnessValues( " << endl;
   Pop.printFitnessValues(cout);
   cout << "After the  Pop.printFitnessValues( " << endl;

}// end of apply()

